Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.math.stat.descriptive.moment
Class FourthMoment

    java.lang.Object
      org.apache.commons.math.stat.descriptive.AbstractUnivariateStatistic
          org.apache.commons.math.stat.descriptive.AbstractStorelessUnivariateStatistic
              org.apache.commons.math.stat.descriptive.moment.FirstMoment
                  org.apache.commons.math.stat.descriptive.moment.SecondMoment
                      org.apache.commons.math.stat.descriptive.moment.ThirdMoment
                          org.apache.commons.math.stat.descriptive.moment.FourthMoment

All Implemented Interfaces:
  Serializable, StorelessUnivariateStatistic, UnivariateStatistic

public class FourthMoment
extends ThirdMoment
implements Serializable

Computes a statistic related to the Fourth Central Moment. Specifically, what is computed is the sum of

(x_i - xbar) ^ 4,

where the x_i are the sample observations and xbar is the sample mean.

The following recursive updating formula is used:

Let

- dev = (current obs - previous mean)
- m2 = previous value of `SecondMoment`
- m2 = previous value of `ThirdMoment`
- n = number of observations (including current obs)

Then

new value = old value - 4 * (dev/n) * m3 + 6 * (dev/n)^2 * m2 +
[n^2 - 3 * (n-1)] * dev^4 * (n-1) / n^3

Returns `Double.NaN` if no data values have been added and returns `0` if there is just one value in the data set.

Note that this implementation is not synchronized. If multiple threads access an instance of this class concurrently, and at least one of the threads invokes the `increment()` or `clear()` method, it must be synchronized externally.

Version:
  $Revision: 1.1 $ $Date: 2004/10/08 05:08:17 $
See Also:
  Serialized Form

Field Summary
`protected double` | `m4` fourth moment of values that have been added
`(package private) static long` | `serialVersionUID` Serializable version identifier

Fields inherited from class org.apache.commons.math.stat.descriptive.moment.ThirdMoment
`m3, nDevSq`

Fields inherited from class org.apache.commons.math.stat.descriptive.moment.SecondMoment
`m2`

Fields inherited from class org.apache.commons.math.stat.descriptive.moment.FirstMoment
`dev, m1, n, nDev`

Constructor Summary
`FourthMoment()` Create a FourthMoment instance

Method Summary
`void` | `clear()` Clears the internal state of the Statistic
`double` | `getResult()` Returns the current value of the Statistic.
`void` | `increment(double d)` Updates the internal state of the statistic to reflect the addition of the new value.

Methods inherited from class org.apache.commons.math.stat.descriptive.moment.FirstMoment
`getN`

Methods inherited from class org.apache.commons.math.stat.descriptive.AbstractStorelessUnivariateStatistic
`equals, evaluate, evaluate, hashCode, incrementAll, incrementAll`

Methods inherited from class org.apache.commons.math.stat.descriptive.AbstractUnivariateStatistic
`test`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### serialVersionUID

    static final long serialVersionUID

  Serializable version identifier

  See Also:
    Constant Field Values

### m4

    protected double m4

  fourth moment of values that have been added

Constructor Detail

### FourthMoment

    public FourthMoment()

  Create a FourthMoment instance

Method Detail

### increment

    public void increment(double d)

  Description copied from interface: `StorelessUnivariateStatistic`
  Updates the internal state of the statistic to reflect the addition of the new value.

  Specified by:
    `increment` in interface `StorelessUnivariateStatistic`
  Overrides:
    `increment` in class `ThirdMoment`
  See Also:
    `StorelessUnivariateStatistic.increment(double)`

### getResult

    public double getResult()

  Description copied from interface: `StorelessUnivariateStatistic`
  Returns the current value of the Statistic.

  Specified by:
    `getResult` in interface `StorelessUnivariateStatistic`
  Overrides:
    `getResult` in class `ThirdMoment`
  See Also:
    `StorelessUnivariateStatistic.getResult()`

### clear

    public void clear()

  Description copied from interface: `StorelessUnivariateStatistic`
  Clears the internal state of the Statistic

  Specified by:
    `clear` in interface `StorelessUnivariateStatistic`
  Overrides:
    `clear` in class `ThirdMoment`
  See Also:
    `StorelessUnivariateStatistic.clear()`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2004 The Apache Software Foundation. All Rights Reserved.